#include "aplot.h"
#include "qtablewidget.h"
#include "qdebug.h"

aplot::aplot()
{
}

void histogram(QVector<double> data, QVector<double> bin, QCustomPlot* graph){
    QVector<int> binCount;
    QVector<double> x, y;
    binCount.fill(0,bin.size()+1);

    qSort(data.begin(),data.end());
    qSort(bin.begin(),bin.end());

    int prevCount=0;
    int counter=0;

    for (int i=0; i<bin.size();i++){
        if (data.size()>counter)
            while (data.at(counter)<bin.at(i)){
                counter++;
                if (data.size()<=counter)
                    break;
            }

        binCount[i]=counter-prevCount;
        prevCount=counter;
    }
    binCount[bin.size()]=data.size()-prevCount;

    x.clear();
    y.clear();
    double yMax=0;

    for(int i=1;i<(binCount.size()-1);i++){
        y<<(double)binCount.at(i);
        y<<(double)binCount.at(i);
        x<<(bin.at(i-1)+0.00000001);
        x<<bin.at(i);
        if (yMax<binCount.at(i))
            yMax=binCount.at(i);
    }

//    qDebug()<<x;
//    qDebug()<<y;

    graph->addGraph();
    graph->graph(graph->graphCount()-1)->setData(x,y);
  //  graph->xAxis->setRange(bin.first(),bin.last());
    graph->yAxis->setRange(0, yMax);
    graph->replot();
}

void histogram(QTableWidget* table, QCustomPlot* graph, int numBin){
    QVector<double> tempDV, bin;
    bool isDouble;
    double tempD;
    tempDV.clear();
    bin.clear();

    for (int i=0;i<numBin;i++)
        bin<<graph->xAxis->range().size()/numBin*i+graph->xAxis->range().lower;

    for (int i=0;i<table->rowCount();i++)
        if (table->item(i,table->currentColumn())!=0){
            tempD=table->item(i,table->currentColumn())->text().toDouble(&isDouble);
            if (isDouble&tempD==tempD)
                tempDV<<tempD;
        }

    qDebug()<<tempDV;

    histogram(tempDV,bin,graph);
}
