#include "csv.h"
#include <QFile>
#include <QTextStream>
#include <QVector>
#include <QStringList>
#include <QDebug>
#include <qmessagebox.h>


void csvwrite(QString fileLocation, QVector<QVector<double> > data){
    QFile outputFile(fileLocation);
    outputFile.open(QIODevice::WriteOnly);

    /* Check it opened OK */
    if(!outputFile.isOpen()){
        qDebug() << "Error, unable to save";

    }else if(data.size()!=0){

    /* Point a QTextStream object at the file */
    QTextStream outStream(&outputFile);

    /* Write the line to the file */

    for (int i=0;i<data.size();i++){
        for (int j=0;j<data.at(i).size()-1;j++){
            outStream << data.at(i).at(j) <<",";
        }
        if (data.at(i).size()>0)
            outStream << data.at(i).last();
        outStream <<"\n";
    }
}
}

void csvwrite(QString fileLocation, QVector<QVector<double> > data, QStringList label){
    QFile outputFile(fileLocation);
    outputFile.open(QIODevice::WriteOnly);

    /* Check it opened OK */
    if(!outputFile.isOpen()){
        qDebug() << "Error, unable to save";

    }else if(data.size()!=0){

    /* Point a QTextStream object at the file */
    QTextStream outStream(&outputFile);

    /* Write the line to the file */

    for (int i=0; i<<label.size()-1; i++){
        outStream << label.at(i);
        outStream << ",";
    }
    if (label.size()>0)
        outStream <<label.at(label.size()-1);

    outStream <<"\n";

    /* Write the line to the file */

    for (int i=0;i<data.size();i++){
        for (int j=0;j<data.at(i).size()-1;j++){
            outStream << data.at(i).at(j) <<",";
        }
        if (data.at(i).size()>0)
            outStream << data.at(i).last();
        outStream <<"\n";
    }
}
}


void csvwrite(QString fileLocation, QTableWidget *table){
    QFile outputFile(fileLocation);
    outputFile.open(QIODevice::WriteOnly);

    /* Check it opened OK */
    if(!outputFile.isOpen()){
        qDebug() << "Error, unable to save";

    }else{

        /* Point a QTextStream object at the file */
        QTextStream outStream(&outputFile);

        /* Write the line to the file */

        for (int i=0; i<table->rowCount()-1; i++){
            for (int j=0;j<table->columnCount()-1; j++){
                if (table->item(i,j)!=0){
                    outStream<<table->item(i,j)->text()<<",";
                }else{
                    outStream<<" ,";
                }
            }
            if (table->item(i,table->columnCount()-1)!=0){
                outStream<<table->item(i,table->columnCount()-1)->text()<<"\n";
            }else{
                outStream<<" \n";
            }
        }

        for (int j=0;j<table->columnCount()-1; j++){
            if (table->item(table->rowCount()-1,j)!=0){
                outStream<<table->item(table->rowCount()-1,j)->text()<<",";
            }else{
                outStream<<" ,";
            }
        }
        if (table->item(table->rowCount()-1,table->columnCount()-1)!=0){
            outStream<<table->item(table->rowCount()-1,table->columnCount()-1)->text();
        }else{
            outStream<<" ";
        }
    }



}

void csvwrite(QString fileLocation, QTableWidget *table, int startRow){
    QFile outputFile(fileLocation);
    outputFile.open(QIODevice::WriteOnly);

    /* Check it opened OK */
    if(!outputFile.isOpen()){
        qDebug() << "Error, unable to save";

    }else{

        /* Point a QTextStream object at the file */
        QTextStream outStream(&outputFile);

        /* Write the line to the file */

        for (int i=startRow; i<table->rowCount()-1; i++){
            for (int j=0;j<table->columnCount()-1; j++){
                if (table->item(i,j)!=0){
                    outStream<<table->item(i,j)->text()<<",";
                }else{
                    outStream<<" ,";
                }
            }
            if (table->item(i,table->columnCount()-1)!=0){
                outStream<<table->item(i,table->columnCount()-1)->text()<<"\n";
            }else{
                outStream<<" \n";
            }
        }

        for (int j=0;j<table->columnCount()-1; j++){
            if (table->item(table->rowCount()-1,j)!=0){
                outStream<<table->item(table->rowCount()-1,j)->text()<<",";
            }else{
                outStream<<" ,";
            }
        }
        if (table->item(table->rowCount()-1,table->columnCount()-1)!=0){
            outStream<<table->item(table->rowCount()-1,table->columnCount()-1)->text();
        }else{
            outStream<<" ";
        }
    }



}

QVector<QVector<double> > csvReadToDouble(QString fileName){

    QFile file(fileName);
    QMessageBox newMessage;
    QString stringOut;
    QStringList tempSL;
    stringOut.clear();
    QVector<QVector<double> > out;
    QVector<double> temp;
    bool isDouble;
    double tempDouble;
    bool warningOff=true;
    out.clear();

    if (file.exists()){
        if (file.open(QIODevice::ReadOnly)){
            QTextStream in(&file);

            while(!in.atEnd()) {
                temp.clear();
                tempSL = in.readLine().split(",");
                for (int i=0;i<tempSL.size();i++){
                    tempDouble=tempSL[i].toDouble(&isDouble);
                    if(isDouble){
                        temp<<tempDouble;
                    }else{
                        temp<<0.0/0.0;
                    }

                }
                out<<temp;
            }
            file.close();
        }else if (!warningOff){
            newMessage.setText("file "+fileName+" cannot be opened");
        }

    }else if (!warningOff){
        newMessage.setText("file "+fileName+" cannot be found");
    }
    return out;
}

QVector<QVector<double> > csvWithHeaderReadToDouble(QString fileName){

    QFile file(fileName);
    QMessageBox newMessage;
    QString stringOut;
    QStringList tempSL;
    stringOut.clear();
    QVector<QVector<double> > out;
    QVector<double> temp;
    bool isDouble;
    double tempDouble;
    bool warningOff=true;
    out.clear();

    if (file.exists()){
        if (file.open(QIODevice::ReadOnly)){
            QTextStream in(&file);
            in.readLine();

            while(!in.atEnd()) {
                temp.clear();
                tempSL = in.readLine().split(",");
                for (int i=0;i<tempSL.size();i++){
                    tempDouble=tempSL[i].toDouble(&isDouble);
                    if(isDouble){
                        temp<<tempDouble;
                    }else{
                        temp<<0.0/0.0;
                    }

                }
                out<<temp;
            }
            file.close();
        }else if (!warningOff){
            newMessage.setText("file "+fileName+" cannot be opened");
        }

    }else if (!warningOff){
        newMessage.setText("file "+fileName+" cannot be found");
    }
    return out;
}


QStringList csvWithHeaderReadHeader(QString fileName){

    QFile file(fileName);
    QMessageBox newMessage;
    QString stringOut;
    QStringList tempSL;
    stringOut.clear();
    QVector<QVector<double> > out;
    QVector<double> temp;
    bool isDouble;
    double tempDouble;
    bool warningOff=true;
    out.clear();

    if (file.exists()){
        if (file.open(QIODevice::ReadOnly)){
            QTextStream in(&file);

            if(!in.atEnd()) {
                tempSL = in.readLine().split(",");
            }
            file.close();
        }else if (!warningOff){
            newMessage.setText("file "+fileName+" cannot be opened");
        }

    }else if (!warningOff){
        newMessage.setText("file "+fileName+" cannot be found");
    }
    return tempSL;
}

void csvDisplay(QTableWidget *table, QVector<QVector<double> > data){
    table->setRowCount(data.size());
    if (data.size()>0){
        table->setColumnCount(data.last().size());
        for (int i=0; i<data.size(); i++){

            if (table->columnCount()<data.at(i).size())
                table->setColumnCount(data.at(i).size());

            for (int j=0;j<table->columnCount();j++){
                if (j<data.at(i).size()){
                    table->setItem(i,j,new QTableWidgetItem(QString::number(data.at(i).at(j))));
                }else{
                    table->setItem(i,j,new QTableWidgetItem("NaN"));
                }
            }

        }
    }

}

void csvDisplay(QTableWidget *table, QVector<QVector<double> > data, QStringList label){
    csvDisplay(table,data);
    if (table->colorCount()<label.size())
        table->setColumnCount(label.size());


    for (int i=0;i<label.size();i++)
        table->setHorizontalHeaderItem(i,new QTableWidgetItem(label.at(i)));

}
