#include "endpoint.h"
#include <qdebug.h>
#include <randomng.h>
#include <math.h>
#include <QtConcurrent>
#include <endpointparsercontainer.h>

endPoint::endPoint()
{

}


double endPoint::evaluateEndpoint(double indepVariable, QVector<double> rawResDataRow){
    QVector<double> variableValues;
    double out;
    variableValues.fill(0.0/0.0,epParser.variable_names.size());
    variableValues[2]=indepVariable;
    QStringList variableNames=epParser.variable_names;

    QVector <int> ETA_locations,ETA_indecies;
    ETA_locations.clear();
    ETA_indecies.clear();
    currentETAmax=0;

    for (int i=0;i<variableNames.size();i++)
        if(variableNames.at(i)=="ofv"&rawResDataRow.size()>19){
            variableValues[i]=rawResDataRow.at(20-1);

        }else{
            bool isInt;
            int tempInd;
            if (variableNames[i].split("col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("COL",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("COL",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("ETA",QString::SkipEmptyParts).size()==1){
                tempInd=variableNames[i].split("ETA",QString::SkipEmptyParts).at(0).toInt(&isInt);
                    if (isInt){
                        if (tempInd>currentETAmax)
                            currentETAmax=tempInd;

                        ETA_locations<<i;
                        ETA_indecies<<tempInd-1;
                        this->randomEffect=true;
                        if (tempInd>this->numETA){


                            this->omegaMatrix.resize(tempInd);
                            for (int j=0;j<this->numETA;j++){
                                for (int k=this->numETA;k<tempInd;k++)
                                this->omegaMatrix[j]<<0;
                            }

                            for (int j=this->numETA;j<tempInd;j++){
                                this->omegaMatrix[j].fill(0,tempInd);
                                this->omegaMatrix[j][j]=1;
                            }

                            this->omegaIndecies.resize(tempInd);
                            for (int j=0;j<this->numETA;j++){
                                for (int k=this->numETA;k<tempInd;k++)
                                this->omegaIndecies[j]<<-1;
                            }

                            for (int j=this->numETA;j<tempInd;j++){
                                this->omegaIndecies[j].fill(-1,tempInd);
                            }
                            numETA=tempInd;
                        }
                    }
                //variableValues[i]=rawResDataRow.at(tempInd+this->THETA_index-1);
            }

            if (variableNames[i].split("THETA",QString::SkipEmptyParts).size()==1){
            tempInd=variableNames[i].split("THETA",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd+this->THETA_index-2);
            }
        }

    if (ETA_locations.size()>0){
        for (int i=0;i<numETA;i++)
            for (int j=0;j<i+1;j++){
                if (omegaIndecies.at(i).at(j)>=0){
                    omegaMatrix[i][j]=rawResDataRow.at(omegaIndecies.at(i).at(j));
                    omegaMatrix[j][i]=rawResDataRow.at(omegaIndecies.at(i).at(j));
                }
            }

        randomNG myRNG;

        QVector<double> tempDV, tempDV2;
        double tempD;
        tempDV.clear();
        tempD=0;
        int numSample=100;

        for (int i=0;i<numSample;i++){
            tempDV2=myRNG.multiNormal(omegaMatrix);
            for (int j=0; j<ETA_locations.size();j++){
                variableValues[ETA_locations.at(j)]=tempDV2.at(ETA_indecies.at(j));
            }
            if (this->iivEndpoint>=0){
                tempDV<<this->epParser.evaluate_tree(variableValues);
            }else{
                tempD=tempD+this->epParser.evaluate_tree(variableValues);
            }
        }

        if (this->iivEndpoint>=0){
            qSort(tempDV.begin(),tempDV.end());
            int tempI=floor((double)this->iivEndpoint/(double)100*(double)numSample);
            if(tempI>=0&tempI<tempDV.size()){
                return tempDV.at(tempI);
            }else{
                return 0.0/0.0;
            }
        }else{
            return tempD/(double)numSample;
        }


    }else{
        this->randomEffect=false;
        out= this->epParser.evaluate_tree(variableValues);
    }
    return out;
}

QVector<double> endPoint::evaluateEndpoint(QVector<double> rawResDataRow){

    QVector<double> variableValues;
    QVector<endPointParserContainer> endPPCVector;
    double out;
    variableValues.fill(0.0/0.0,epParser.variable_names.size());
    QStringList variableNames=epParser.variable_names;

    QVector <int> ETA_locations,ETA_indecies;
    ETA_locations.clear();
    ETA_indecies.clear();
    currentETAmax=0;


    for (int i=0;i<variableNames.size();i++)
        if(variableNames.at(i)=="ofv"&rawResDataRow.size()>19){
            variableValues[i]=rawResDataRow.at(20-1);

        }else{
            bool isInt;
            int tempInd;
            if (variableNames[i].split("col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("COL",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("COL",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("ETA",QString::SkipEmptyParts).size()==1){
                tempInd=variableNames[i].split("ETA",QString::SkipEmptyParts).at(0).toInt(&isInt);
                    if (isInt){
                        if (tempInd>currentETAmax)
                            currentETAmax=tempInd;

                        ETA_locations<<i;
                        ETA_indecies<<tempInd-1;
                        this->randomEffect=true;
                        if (tempInd>this->numETA){


                            this->omegaMatrix.resize(tempInd);
                            for (int j=0;j<this->numETA;j++){
                                for (int k=this->numETA;k<tempInd;k++)
                                this->omegaMatrix[j]<<0;
                            }

                            for (int j=this->numETA;j<tempInd;j++){
                                this->omegaMatrix[j].fill(0,tempInd);
                                this->omegaMatrix[j][j]=1;
                            }

                            this->omegaIndecies.resize(tempInd);
                            for (int j=0;j<this->numETA;j++){
                                for (int k=this->numETA;k<tempInd;k++)
                                this->omegaIndecies[j]<<-1;
                            }

                            for (int j=this->numETA;j<tempInd;j++){
                                this->omegaIndecies[j].fill(-1,tempInd);
                            }
                            numETA=tempInd;
                        }
                    }
                //variableValues[i]=rawResDataRow.at(tempInd+this->THETA_index-1);
            }

            if (variableNames[i].split("THETA",QString::SkipEmptyParts).size()==1){
            tempInd=variableNames[i].split("THETA",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                if(tempInd+this->THETA_index-2<rawResDataRow.size()){
                    variableValues[i]=rawResDataRow.at(tempInd+this->THETA_index-2);
                }else{
                    variableValues[i]=0.0/0.0;
                }
            }
        }

    QVector<double> outDV;

    outDV.clear();

    for(int l=0;l<indepVariables.size();l++){
        variableValues[2]=indepVariables.at(l);;

        if (ETA_locations.size()>0){
            for (int i=0;i<numETA;i++)
                for (int j=0;j<i+1;j++){
                    if (omegaIndecies.at(i).at(j)>=0){
                        omegaMatrix[i][j]=rawResDataRow.at(omegaIndecies.at(i).at(j));
                        omegaMatrix[j][i]=rawResDataRow.at(omegaIndecies.at(i).at(j));
                    }
                }

            randomNG myRNG;

            QVector<double> tempDV, tempDV2;
            double tempD;
            tempDV.clear();
            tempD=0;

            int numCores=QThread::idealThreadCount();
            endPPCVector.resize(numCores);
            int simPerCore=ceil(numSample/numCores);

            if (numSample>1){

            for (int ii=0;ii<numCores;ii++){

                endPPCVector[ii].clearVariables();

                for (int i=0;i<simPerCore;i++){
                    tempDV2=myRNG.multiNormal(omegaMatrix);
                    for (int j=0; j<ETA_locations.size();j++){
                        variableValues[ETA_locations.at(j)]=tempDV2.at(ETA_indecies.at(j));
                    }
                    endPPCVector[ii].addVariable(variableValues);
                    endPPCVector[ii].setParser(this->epParser);
                }
            }


                QtConcurrent::blockingMap(endPPCVector,evaluateEPParser);
                //fugure.waitForFinished();
                for (int ii=0;ii<numCores;ii++){
                    if (this->iivEndpoint>=0){
                        tempDV<<endPPCVector[ii].ans;
                    }else{
                        for (int i=0;i<simPerCore;i++){
                            tempD=tempD+endPPCVector[ii].ans.at(i);
                        }
                    }
                }

            }else if(numSample==1){
                for (int i=0;i<numSample;i++){
                    tempDV2=myRNG.multiNormal(omegaMatrix);
                    for (int j=0; j<ETA_locations.size();j++){
                        variableValues[ETA_locations.at(j)]=tempDV2.at(ETA_indecies.at(j));
                    }

                    if (this->iivEndpoint>=0){
                        tempDV<<this->epParser.evaluate_tree(variableValues);
                    }else{
                        tempD=tempD+this->epParser.evaluate_tree(variableValues);
                    }
                }


            }



//            endPPCVector.clear();

            if (this->iivEndpoint>=0){
                qSort(tempDV.begin(),tempDV.end());
                int tempI=floor((double)this->iivEndpoint/(double)100*(double)numSample);
                if(tempI>=0&tempI<tempDV.size()){
                    out= tempDV.at(tempI);
                }else{
                    out= 0.0/0.0;
                }
            }else{
                out= tempD/(double)numSample;
            }


        }else{
            this->randomEffect=false;
            out= this->epParser.evaluate_tree(variableValues);
        }

        outDV<<out;
    }

    return outDV;

}

double endPoint::evaluateWeight(QVector<double> rawResDataRow){
    QVector<double> variableValues;

    QStringList variableNames=this->weightParser.extract_variables();

    variableValues.fill(0.0/0.0,variableNames.size());

    for (int i=0;i<variableNames.size();i++)
        if(variableNames.at(i)=="ofv"&rawResDataRow.size()>this->OFV_index-1){
            variableValues[i]=rawResDataRow.at(this->OFV_index-1);

        }else{
            bool isInt;
            int tempInd;
            if (variableNames[i].split("col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Col",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Col",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("COL",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("COL",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }

            if (variableNames[i].split("Column",QString::SkipEmptyParts).size()>0){
            tempInd=variableNames[i].split("Column",QString::SkipEmptyParts).at(0).toInt(&isInt);
            if (isInt)
                variableValues[i]=rawResDataRow.at(tempInd-1);
            }
        }

    if (weightParser.expression.size()==0){
        return 0.0/0.0;
    }else{
        return this->weightParser.evaluate_tree(variableValues);
    }
}


void endPoint::checkETA(){

    if(!epParser.expression.isEmpty()){
    QStringList variableNames=epParser.extract_variables();

    QVector <int> ETA_locations;
    ETA_locations.clear();
    currentETAmax=0;
    int tempInd;
    bool isInt;

    for (int i=0;i<variableNames.size();i++)
        if (variableNames[i].split("ETA",QString::SkipEmptyParts).size()==1){
            tempInd=variableNames[i].split("ETA",QString::SkipEmptyParts).at(0).toInt(&isInt);
                if (isInt){
                    if (tempInd>currentETAmax)
                        currentETAmax=tempInd;

                    ETA_locations<<tempInd;
                    this->randomEffect=true;
                    if (tempInd>this->numETA){


                        this->omegaMatrix.resize(tempInd);
                        for (int j=0;j<this->numETA;j++){
                            for (int k=this->numETA;k<tempInd;k++)
                            this->omegaMatrix[j]<<0;
                        }

                        for (int j=this->numETA;j<tempInd;j++){
                            this->omegaMatrix[j].fill(0,tempInd);
                            this->omegaMatrix[j][j]=1;
                        }

                        this->omegaIndecies.resize(tempInd);
                        for (int j=0;j<this->numETA;j++){
                            for (int k=this->numETA;k<tempInd;k++)
                            this->omegaIndecies[j]<<-1;
                        }

                        for (int j=this->numETA;j<tempInd;j++){
                            this->omegaIndecies[j].fill(-1,tempInd);
                        }
                        numETA=tempInd;
                    }
                }
            //variableValues[i]=rawResDataRow.at(tempInd+this->THETA_index-1);
        }
    }
}

void evaluateEPParser(endPointParserContainer &in_ePPC){

    in_ePPC.ans.clear();
    for(int i=0; i<in_ePPC.variables.size();i++)
        in_ePPC.ans<<in_ePPC.myParser.evaluate_tree(in_ePPC.variables.at(i));

}
