#ifndef ENDPOINT_H
#define ENDPOINT_H
#include <QString>
#include <parser.h>
#include <endpointparsercontainer.h>

class endPoint
{
public:
    endPoint();

    QString name;
    QString endpointDefinition;
    QVector<int> variableIndecies;
    QVector<int> weightVariableIndecies;
    QVector<double> indepVariables;
    QVector<QString> variableDictionary;

    double evaluateEndpoint(double indepVariable, QVector<double> rawResDataRow);
    QVector<double> evaluateEndpoint(QVector<double> rawResDataRow);
    double evaluateWeight(QVector<double> rawResDataRow);

    parser epParser;
    parser weightParser;
    bool include;

    int THETA_index;
    int ETA_index;
    int OFV_index;

    int numSample=100;

    bool randomEffect=false;
    int numETA=0;
    int currentETAmax=0;
    QVector<QVector<int> > omegaIndecies;
    QVector<QVector<double> > omegaMatrix;

    void checkETA();

    int iivEndpoint=-1;

};

void evaluateEPParser(endPointParserContainer &in_ePPC);

#endif // ENDPOINT_H
