#include "parser.h"
#include <qstringlist.h>
#include <qdebug.h>

parser::parser(QString expression_in)
{
    this->expression=expression_in;
    operators=(QStringList()<<"^"<<"*"<<"/"<<"+"<<"-"<<"exp("<<"log("<<"log10("<<"Abs("<<"Sign("<<"Sqrt("<<"Sin("<<"Cos("<<"Tan("<<"ASin("<<"ACos("<<"ATan(")<<"("<<")";
    operatorValues<<0<<1<<2<<3<<4<<102<<103<<104<<105<<106<<107<<108<<109<<110<<111<<112<<113<<100<<101;
    operatorPrecedance<<4<<3<<3<<2<<2<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100;
    operatorLeftAssociativity<<false<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true;
}

parser::parser()
{
    operators=(QStringList()<<"^"<<"*"<<"/"<<"+"<<"-"<<"exp("<<"log("<<"log10("<<"Abs("<<"Sign("<<"Sqrt("<<"Sin("<<"Cos("<<"Tan("<<"ASin("<<"ACos("<<"ATan(")<<"("<<")";
    operatorValues<<0<<1<<2<<3<<4<<102<<103<<104<<105<<106<<107<<108<<109<<110<<111<<112<<113<<100<<101;
    operatorPrecedance<<4<<3<<3<<2<<2<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100<<100;
    operatorLeftAssociativity<<false<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true<<true;
}



QStringList parser::extract_variables(){
    QStringList tempSL=expression.split(" ", QString::SkipEmptyParts);
    QStringList tempSL2;
    bool isDouble;

    for (int i=0;i<operators.size();i++){
        tempSL2.clear();
        for (int j=0; j<tempSL.size();j++){
            tempSL2<<tempSL[j].split(operators.at(i), QString::SkipEmptyParts,Qt::CaseInsensitive);
        }
        tempSL=tempSL2;
    }
    tempSL.removeDuplicates();

    for(int i=0;i<tempSL.size();i++){
        tempSL[i].toDouble(&isDouble);
        if (isDouble){
            tempSL.removeAt(i);
            i--;
        }
    }


    QStringList possibleTimeExpressions, possibleCexpressions, possibleEexpressions;
    possibleTimeExpressions<<"Time"<<"TIME"<<"t"<<"T"<<"time";
    possibleCexpressions<<"C"<<"c"<<"Ce"<<"ce"<<"CE"<<"cE"<<"Cp"<<"cp"<<"cP"<<"CP"<<"Concentration"<<"concentration";
    possibleEexpressions<<"DOSE"<<"dose"<<"IndepVariable"<<"Dose";

    int i=0;
    while(tempSL.indexOf(possibleEexpressions.at(i))==-1){
        i++;
        if (i>=possibleEexpressions.size()){
            i=0;
            break;
        }
    }

    while(tempSL.indexOf(possibleEexpressions.at(i))!=-1){
        tempSL.removeAt(tempSL.indexOf(possibleEexpressions.at(i)));
    }

    tempSL.push_front(possibleEexpressions.at(i));

    i=0;
    while(tempSL.indexOf(possibleCexpressions.at(i))==-1){
        i++;
        if (i>=possibleCexpressions.size()){
            i=0;
            break;
        }
    }

    while(tempSL.indexOf(possibleCexpressions.at(i))!=-1){
        tempSL.removeAt(tempSL.indexOf(possibleCexpressions.at(i)));
    }

    tempSL.push_front(possibleCexpressions.at(i));

    i=0;
    while(tempSL.indexOf(possibleTimeExpressions.at(i))==-1){
        i++;
        if (i>=possibleTimeExpressions.size()){
            i=0;
            break;
        }
    }
    while(tempSL.indexOf(possibleTimeExpressions.at(i))!=-1){
        tempSL.removeAt(tempSL.indexOf(possibleTimeExpressions.at(i)));
    }

    tempSL.push_front(possibleTimeExpressions.at(i));

    tempSL.removeDuplicates();

    variable_names=tempSL;

    return tempSL;
}

void parser::generate_tree(){


    QVector<parser_token> tempTokenList,tempTokenList2, outputStack, operatorStack;
    parser_token tempPT;

    this->extract_variables();

    tempPT.rawExpression=this->expression;
    tempTokenList.clear();

    tempTokenList<<tempPT;

    for(int i=0;i<operators.size();i++){
        tempTokenList2.clear();
        for(int j=0;j<tempTokenList.size();j++){
            if (operators.at(i)=="("){
            if (tempTokenList[j].rawExpression!="exp("&tempTokenList[j].rawExpression!="log("&tempTokenList[j].rawExpression!="log10("&tempTokenList[j].rawExpression!="Abs("&tempTokenList[j].rawExpression!="Sign("&tempTokenList[j].rawExpression!="Sqrt("&tempTokenList[j].rawExpression!="Sin("&tempTokenList[j].rawExpression!="Cos("&tempTokenList[j].rawExpression!="Tan("&tempTokenList[j].rawExpression!="ASin("&tempTokenList[j].rawExpression!="ACos("&tempTokenList[j].rawExpression!="ATan("){
                tempTokenList2<<tempTokenList[j].split(operators.at(i),2,operatorValues.at(i));
            }else{
                tempTokenList2<<tempTokenList[j];
            }
            }else{
                tempTokenList2<<tempTokenList[j].split(operators.at(i),2,operatorValues.at(i));
            }
        }
        tempTokenList=tempTokenList2;
    }

    for(int i=0;i<tempTokenList.size();i++)
        if(tempTokenList.at(i).type==-1&variable_names.indexOf(tempTokenList.at(i).rawExpression)!=-1){
            tempTokenList[i].type=1;
            tempTokenList[i].value=(double)variable_names.indexOf(tempTokenList.at(i).rawExpression);
            tempTokenList[i].text=variable_names.indexOf(tempTokenList.at(i).rawExpression);
        }else if(tempTokenList.at(i).type==2){
            int opIndex=operatorValues.indexOf((int)tempTokenList.at(i).value);
            tempTokenList[i].leftAssoc=operatorLeftAssociativity.at(opIndex);
            tempTokenList[i].precedance=operatorPrecedance.at(opIndex);
            tempTokenList[i].text=operators.at(opIndex);
        }

    for(int i=0;i<tempTokenList.size();i++)
        if (tempTokenList.at(i).type!=2){
            outputStack<<tempTokenList.at(i);
        }else if(operatorStack.size()==0){
            operatorStack.push_front(tempTokenList.at(i));
        }else if(tempTokenList.at(i).value==101){
            while(operatorStack.first().value<100){
                outputStack<<operatorStack.first();
                operatorStack.pop_front();
                if (operatorStack.size()==0)
                    break;
            }
            if (operatorStack.size()!=0)
                if (operatorStack.first().type==2&operatorStack.first().value>=100){
                    outputStack<<operatorStack.first();
                    operatorStack.pop_front();
                }

        }else{
            if (tempTokenList.at(i).value<100){
                while((operatorStack.first().type==2&operatorStack.first().value<100)&((operatorStack.first().leftAssoc&operatorStack.first().precedance==tempTokenList.at(i).precedance)|operatorStack.first().precedance>tempTokenList.at(i).precedance)){
                    outputStack<<operatorStack.first();
                    operatorStack.pop_front();
                    if (operatorStack.size()==0)
                        break;
                }
            }

            operatorStack.push_front(tempTokenList.at(i));
        }

    outputStack<<operatorStack;

    this->tree=outputStack;
}

double parser::evaluate_tree(QVector<double> variables_in){
    double out;
    QVector<parser_token> tempTree=tree;
    if (this->tree.isEmpty()){
        qDebug()<<"the parser tree does not exist";
    }else{
        int parsingIndex=0;
        while(tempTree.size()>1){
            if (tempTree.size()>parsingIndex){
                while (tempTree.at(parsingIndex).type!=2){
                    if (tempTree.size()>parsingIndex+1){
                        parsingIndex++;
                    } else{
                        break;
                    }
                }
                if (tempTree.at(parsingIndex).value>=100&parsingIndex>0){
                    tempTree[parsingIndex].operate(tempTree.at(parsingIndex-1),variables_in);
                    tempTree.remove(parsingIndex-1);
                }else if(parsingIndex>1){
                    tempTree[parsingIndex].operate(tempTree.at(parsingIndex-2),tempTree.at(parsingIndex-1),variables_in);
                    tempTree.remove(parsingIndex-1);
                    tempTree.remove(parsingIndex-2);
                    parsingIndex--;
                }else{
                    break;
                }
            }else{
                break;
            }

        }
        if (tempTree.size()==1&tempTree.at(0).type!=-2){
            out=tempTree.at(0).value;
        }else{
            out=0/0;
        }

    }

    return out;

}
