#include "parser_token.h"
#include <math.h>
#include <qdebug.h>


/*
Operator numbers:
0: ^
1: *
2: /
3: +
4: -

100: (
101: )
102: exp(
103: log(
104: log10(
105: Abs(
106: Sign(
107: Sqrt(
108: Sin(
109: Cos(
110: Tan(
111: ASin(
112: ACos(
113: ATan(
*/

parser_token::parser_token()
{
}

QVector<parser_token> parser_token::split(QString symbol, int type_in, double value_in){

    QStringList tempSL;
    QVector<parser_token> out;
    parser_token tempPT, targetPT;
    bool isDouble;
    double tempD;
    out.clear();

    targetPT.rawExpression.clear();
    targetPT.rawExpression=symbol;
    targetPT.value=value_in;
    targetPT.type=type_in;
    targetPT.text=symbol;

    QString keyCharacter="$";
    QVector<int> symbolLocation;
    symbolLocation.clear();

    rawExpression.replace(symbol,keyCharacter);

    QString tempExpression=this->rawExpression;

    tempSL.clear();

    while(tempExpression.length()>0)
        if (tempExpression.indexOf(keyCharacter)!=-1){
            if (tempExpression.indexOf(keyCharacter)==0){
                tempExpression.remove(0,1);
                out<<targetPT;

            }else{
                tempPT.rawExpression=tempExpression.left(tempExpression.indexOf(keyCharacter));
                tempD=tempPT.rawExpression.toDouble(&isDouble);
                if (isDouble){
                    tempPT.type=0;
                    tempPT.value=tempD;
                    tempPT.text=QString::number(tempD);
                }else{
                    tempPT.type=-1;
                }
                out<<tempPT;
                out<<targetPT;

                tempSL<<tempExpression.left(tempExpression.indexOf(keyCharacter));
                tempExpression.remove(0,tempExpression.indexOf(keyCharacter)+1);

            }
        }else{
            if (out.size()>0){
                tempSL<<tempExpression;

                tempPT.rawExpression=tempExpression;
                tempD=tempPT.rawExpression.toDouble(&isDouble);
                if (isDouble){
                    tempPT.type=0;
                    tempPT.value=tempD;
                    tempPT.text=QString::number(tempD);
                }else{
                    tempPT.type=-1;
                }
                out<<tempPT;}
            else{

                tempD=this->rawExpression.toDouble(&isDouble);
                if (isDouble){
                    this->type=0;
                    this->value=tempD;
                    this->text=QString::number(tempD);
                }
                out<<*this;
            }

            break;
        }

    return out;
}


void  parser_token::operate(parser_token token, QVector<double> variableValues){
    double tempValue;

    if (this->type!=2|this->value<100|this->value==101){
        qDebug()<<"This token is not an operator";
        this->type=-2;

    }else if(token.type==2|token.type==-2){
        qDebug()<<"Cannot operate on operator";
        this->type=-2;

    }else{


        if(token.type==1){
            if((int)token.value<variableValues.size()){
                tempValue=variableValues.at((int)token.value);
            }else{
                qDebug()<<"not enough variable values";
            }

        }else{
            tempValue=token.value;
        }


            switch((int)this->value){
                case 100:
                    this->value=(tempValue);
                    break;
                case 102:
                    this->value=exp(tempValue);
                    break;
                case 103:
                    this->value=log(tempValue);
                    break;
                case 104:
                    this->value=log(tempValue)/log(10);
                    break;
                case 105:  if (tempValue<0){
                                this->value=-1*tempValue;
                            }else{
                                this->value=tempValue;
                            }
                    break;
                case 106: if (tempValue<0){
                                this->value=-1;
                            }else{
                                this->value=1;
                            }
                    break;
                case 107:
                    this->value=pow(tempValue,0.5);
                    break;
                case 108:
                    this->value=sin(tempValue);
                    break;
                case 109:
                    this->value=cos(tempValue);
                    break;
                case 110:
                    this->value=tan(tempValue);

                    break;
                case 111:
                    this->value=asin(tempValue);
                    break;
                case 112:
                    this->value=acos(tempValue);
                    break;
                case 113:
                    this->value=atan(tempValue);
                    break;
                default:
                    this->value=0/0;
                    break;
            }

            this->type=0;




    }

}

void  parser_token::operate(parser_token leftToken,parser_token rightToken, QVector<double> variableValues){
    double tempValue, rightValue, leftValue;

    if (this->type!=2|this->value>100|this->value==101){
        qDebug()<<"This token is not an operator";
        this->type=-2;

    }else if(rightToken.type==2|leftToken.type==2|rightToken.type==-2|leftToken.type==-2){
        qDebug()<<"Cannot operate on operator";
        this->type=-2;  
    }else{

        if(rightToken.type==1){
            if((int)rightToken.value<variableValues.size()){
                rightValue=variableValues.at((int)rightToken.value);
            }else{
                qDebug()<<"not enough variable values";
            }
        }else{
            rightValue=rightToken.value;
        }

        if(leftToken.type==1){
            if((int)leftToken.value<variableValues.size()){
                leftValue=variableValues.at((int)leftToken.value);
            }else{
                qDebug()<<"not enough variable values";
            }
        }else{
            leftValue=leftToken.value;
        }


        switch((int)this->value){
            case 0:
                this->value=pow(leftValue,rightValue);
                this->type=0;
                break;
            case 1:
                this->value=leftValue*rightValue;
                this->type=0;
                break;
            case 2:
                this->value=leftValue/rightValue;
                this->type=0;
                break;
            case 3:
                this->value=leftValue+rightValue;
                this->type=0;
                break;
            case 4:
                this->value=(leftValue-rightValue);
                this->type=0;
                break;
            default:
                this->value=0/0;
                this->type=0;
                break;
        }

    }

}
